//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "jpeg.hpp"
#include "gifimg.hpp"
#include <pngimage.hpp>
#include <Graphics.hpp>

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
 TLogFont lb1,lb2;
 int pW,pH,top1,left1,top2,left2,psetflg=0;
 TMetafile *Metafile;
 TRect rect,rect1;

 String FNAM,EXT;
 AnsiString Ed1,Ed2,Ed3;

 TBitmap *bmp;


//---------------------------------------------------------------------------

int Load()
{
  bmp = new Graphics::TBitmap();

   if(FNAM !="")
	{
     FNAM = Form1->OpenDialog1->FileName;

    }
   else
	{
	  if(Form1->OpenDialog1->Execute())
	   {
		  FNAM = Form1->OpenDialog1->FileName;

	   }
	  else
	   {
		 return -1;
	   }
	 }

	  EXT = ExtractFileExt(FNAM).UpperCase();

	  if(EXT == ".JPG")
		{
		  TJPEGImage *jpg;
		  jpg=new TJPEGImage();

		  jpg->LoadFromFile(FNAM);
		  bmp->Assign(jpg);
		  delete jpg;
		}
	  if(EXT == ".BMP")
		{
		  bmp->LoadFromFile(FNAM);

		}

	  if(EXT == ".PNG")
		{
		 TPngImage *png;
		 png = new TPngImage();

		 png->LoadFromFile(FNAM);
		 bmp->Assign(png);
		 delete png;
		}

	  if(EXT == ".GIF")
		{
		  TGIFImage *gif;
		  gif = new TGIFImage();
		  gif->LoadFromFile(FNAM);

		  bmp->Assign(gif);
		  delete gif;

		}

   return 1;
}

void Disp()
{
  int dx1,dx2,dx3,dy1,dy2,dy3,wd;


  dx1=Form1->Image1->Width/2+StrToInt(Form1->Edit5->Text);
  dx2=Form1->Image1->Width/2+StrToInt(Form1->Edit7->Text);
  dx3=Form1->Image1->Width/2+StrToInt(Form1->Edit9->Text);

  dy1=50+StrToInt(Form1->Edit4->Text);
  dy2=Form1->Image1->Height/2+100+StrToInt(Form1->Edit6->Text);
  dy3=Form1->Image1->Height/2+100+StrToInt(Form1->Edit8->Text);

  Ed1=Form1->Edit1->Text;
  Ed2=Form1->Edit2->Text;
  Ed3=Form1->Edit3->Text;

  Metafile = new TMetafile;

  Metafile->Enhanced = True;

//		Metafile->MMWidth = Image1->Width * MMPerPixelW;
//		Metafile->MMHeight = Image1->Height * MMPerPixelH;

  Metafile->Width = Form1->Image1->Width;
  Metafile->Height = Form1->Image1->Height;

  TMetafileCanvas *MetafileCanvas = new TMetafileCanvas(Metafile, 0);

  rect = Rect(0,0,Form1->Image1->Width,Form1->Image1->Height);

  Metafile->Width = Form1->Image1->Width;
  Metafile->Height = Form1->Image1->Height;
  MetafileCanvas->Brush->Color=clWhite;
  MetafileCanvas->Pen->Color = clWhite;
  MetafileCanvas->Pen->Width = 1;
  MetafileCanvas->Rectangle(0,0,Form1->Image1->Width,Form1->Image1->Height);

//-------------------------wiǂݍ---------------------

  if(Form1->CheckBox1->Checked==true)
   {
	 if(Load()==-1)
	  {
		goto skip;
	  }


   if(pW>pH)
	  {
		 MetafileCanvas->StretchDraw(rect,bmp);
	  }
   else
	  {
		 float h,hh,w,rate;
		 h=(float)pH;
		 w=(float)pW;
		 rate=w/h;
		 hh=pH/10*rate;

		 rect1=Rect(0,(pH/10-pW/10)/2,pW/10,(int)hh);
		 MetafileCanvas->StretchDraw(rect1,bmp);
	  }

	delete bmp;
   }

skip:

//-----------------------------------------------

		//`悷
  MetafileCanvas->Font->Height =StrToInt(Form1->Label2->Caption);
  MetafileCanvas->Font->Name   = Form1->Label1->Caption;
  MetafileCanvas->Font->Orientation=2700;

  MetafileCanvas->TextOut(dx1,dy1,Ed1);

  MetafileCanvas->Font->Height =StrToInt(Form1->Label4->Caption);
  MetafileCanvas->Font->Name   = Form1->Label3->Caption;

  wd=MetafileCanvas->TextWidth("");

  if(Ed3 !="")
	{
	   MetafileCanvas->TextOut(dx2+wd,dy2,Ed2);
	   MetafileCanvas->TextOut(dx3-wd,dy3,Ed3);
	}
   else
	{
	   MetafileCanvas->TextOut(dx2,dy2,Ed2);
	}
  delete MetafileCanvas;

  Form1->Image1->Picture->Assign(Metafile);  //쐬^t@CImage1ɕ\

}
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  Form1->FontDialog1->Execute();

  Label1->Caption=Form1->FontDialog1->Font->Name;
  Label2->Caption= Form1->FontDialog1->Font->Size;
  Disp();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
  Form1->FontDialog1->Execute();


  Label3->Caption=Form1->FontDialog1->Font->Name;
  Label4->Caption= Form1->FontDialog1->Font->Size;
  Disp();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
 Disp();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
 //print
  rect = Rect(0, 0, Printer()->PageWidth, Printer()->PageHeight);

  Printer()->BeginDoc();

  Printer()->Canvas->StretchDraw(rect, Metafile);

  Printer()->EndDoc();


}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
 Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
  PrinterSetupDialog1->Execute();


  pW=Printer()->PageWidth;
  pH=Printer()->PageHeight;

  Image1->Height=pH/10;
  Image1->Width=pW/10;

  Form1->Width=pW/10+376;
  Form1->Height=pH/10+50;

  if(pH/10+10<752)
	Form1->Height=752;

  Button3->Enabled=true;
  psetflg=255;
  Button4->Enabled=true;

  Disp();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  Label1->Caption="@CI";
  Label2->Caption=20;
  Label3->Caption="@CI";
  Label4->Caption=20;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit4KeyUp(TObject *Sender, WORD &Key, TShiftState Shift)

{
  try
  {
   StrToInt(Edit4->Text);

  }
  catch(...)
   {
	 Edit4->Text=0;
	 TrackBar1->Position=0;
	 return;
   }
  TrackBar1->Position=StrToInt(Edit4->Text);

  Disp();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit5KeyUp(TObject *Sender, WORD &Key, TShiftState Shift)

{
  try
   {
   StrToInt(Edit5->Text);
   }
  catch(...)
	{
	 Edit5->Text=0;
	 TrackBar2->Position=0;
	 return;
	}
  TrackBar2->Position= StrToInt(Edit5->Text);

  Disp();
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Edit6KeyUp(TObject *Sender, WORD &Key, TShiftState Shift)

{
  try
   {
	StrToInt(Edit6->Text);
   }
  catch(...)
   {
	 Edit6->Text=0;
	 TrackBar3->Position=0;
	 return;
   }
  TrackBar3->Position= StrToInt(Edit6->Text);

  Disp();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit7KeyUp(TObject *Sender, WORD &Key, TShiftState Shift)

{
  try
  {
   StrToInt(Edit7->Text);
  }
  catch(...)
   {
	 Edit7->Text=0;
	 TrackBar4->Position=0;
	 return;
   }

  TrackBar4->Position= StrToInt(Edit7->Text);

  Disp();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TrackBar1Change(TObject *Sender)
{
 Edit4->Text=TrackBar1->Position;
 Disp();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TrackBar2Change(TObject *Sender)
{
  Edit5->Text=TrackBar2->Position;
  Disp();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TrackBar3Change(TObject *Sender)
{
  Edit6->Text=TrackBar3->Position;
  Disp();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TrackBar4Change(TObject *Sender)
{
  Edit7->Text=TrackBar4->Position;
  Disp();
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Button7Click(TObject *Sender)
{
  FNAM="";
  Disp();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
  if(psetflg !=0)
	{
	 Disp();
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TrackBar5Change(TObject *Sender)
{
  Edit8->Text=TrackBar5->Position;
  Disp();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TrackBar6Change(TObject *Sender)
{
  Edit9->Text=TrackBar6->Position;
  Disp();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Edit8KeyUp(TObject *Sender, WORD &Key, TShiftState Shift)

{
  try
  {
   StrToInt(Edit8->Text);
  }
  catch(...)
   {
	 Edit8->Text=0;
	 TrackBar5->Position=0;
	 return;
   }

  TrackBar5->Position= StrToInt(Edit8->Text);

  Disp();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit9KeyUp(TObject *Sender, WORD &Key, TShiftState Shift)

{
   try
  {
   StrToInt(Edit9->Text);
  }
  catch(...)
   {
	 Edit9->Text=0;
	 TrackBar6->Position=0;
	 return;
   }

  TrackBar6->Position= StrToInt(Edit9->Text);

  Disp();
}
//---------------------------------------------------------------------------

